<?php
/**
 * The template for displaying Portfolio Archive
 *
 * @package galo
 * @since galo 1.0
 */

get_header(); ?>

	<section id="primary" class="content-area column full">
		<main id="main" class="site-main" role="main">

		<?php if ( have_posts() ) : ?>

			<header class="page-header">
				<h3 class="page-title">
					<?php post_type_archive_title(); ?>
				</h3>
				<?php
					$term_description = term_description();
					if ( ! empty( $term_description ) ) :
						printf( '<div class="taxonomy-description">%s</div>', $term_description );
					endif;
				?>
			</header><!-- .page-header -->
			
			<div id="portfolio-shortcode">

				<div id="masonry-loop" class="clear">
			
					<?php /* Start the Loop */ ?>
					<?php while ( have_posts() ) : the_post(); ?>

						<?php get_template_part( 'content', 'taxonomy' ); ?>

					<?php endwhile; ?>

				</div>

			</div>

			<?php galo_paging_nav(); ?>

			<?php else : ?>

				<?php get_template_part( 'content', 'none' ); ?>

			<?php endif; ?>

		</main><!-- #main -->
	</section><!-- #primary -->

<?php get_footer(); ?>
